A/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('blog.urls', namespace='blog')),
    path('accounts/', include('accounts.urls', namespace='accounts')),
    path('ckeditor/', include('ckeditor_uploader.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

accounts/urls.py
from django.urls import path
from . import views


app_name = 'accounts'
urlpatterns = [
	path('login/', views.user_login, name='user_login'),
	path('register/', views.user_register, name='user_register'),
	path('logout/', views.user_logout, name='user_logout'),
]

blog/urls.py
from django.urls import path
from . import views


app_name = 'blog'
urlpatterns = [
	path('', views.all_articles, name='all_articles'),
	path('<int:id>/<slug:slug>/', views.article_detail, name='article_detail'),
]

accounts/models.py
from django.db import models

# Create your models here.

blog/models.py
from django.db import models
from django.utils import timezone
from django.contrib.auth.models import User
from django.urls import reverse
from ckeditor_uploader.fields import RichTextUploadingField


class PublishedArticlesManager(models.Manager):
	def get_queryset(self):
		return super().get_queryset().filter(status='publish')

class Article(models.Model):
	STATUS = (
		('draft', 'Draft'),
		('publish', 'Publish')
	)
	title = models.CharField(max_length=120)
	slug = models.SlugField(max_length=120, unique=True)
	writer = models.ForeignKey(User, on_delete=models.CASCADE)
	body = RichTextUploadingField()
	publish = models.DateTimeField(default=timezone.now)
	created = models.DateTimeField(auto_now_add=True)
	updated = models.DateTimeField(auto_now=True)
	status = models.CharField(max_length=20, choices=STATUS, default='draft')
	objects = models.Manager()
	published = PublishedArticlesManager()

	def __str__(self):
		return self.title

	def get_absolute_url(self):
		return reverse('blog:article_detail', args=[self.id, self.slug])

accounts/forms.py
from django import forms
from django.contrib.auth.models import User


class UserLoginForm(forms.Form):
	username = forms.CharField(max_length=30, widget=forms.TextInput(attrs={'class':'form-control', 'placeholder':'Your username'}))
	password = forms.CharField(max_length=50, widget=forms.PasswordInput(attrs={'class':'form-control', 'placeholder':'Your password'}))


class UserRegistrationForm(forms.Form):
	username = forms.CharField(max_length=30, widget=forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Your username'}))
	email = forms.EmailField(max_length=50, widget=forms.EmailInput(attrs={'class':'form-control', 'placeholder':'Your Email'}))
	password1 = forms.CharField(label='password', max_length=50, widget=forms.PasswordInput(attrs={'class': 'form-control', 'placeholder': 'Your password'}))
	password2 = forms.CharField(label='confirm password', max_length=50, widget=forms.PasswordInput(attrs={'class': 'form-control', 'placeholder': 'Your password'}))

	def clean_email(self):
		email = self.cleaned_data['email']
		user = User.objects.filter(email=email)
		if user.exists():
			raise forms.ValidationError('This email already exists')
		return email

	# def clean_password2(self):
	# 	p1 = self.cleaned_data['password1']
	# 	p2 = self.cleaned_data['password2']
	#
	# 	if p1 != p2:
	# 		raise forms.ValidationError('passwords must match')
	# 	return p1

	def clean(self):
		cleaned_data = super().clean()
		p1 = cleaned_data.get('password1')
		p2 = cleaned_data.get('password2')

		if p1 and p2:
			if p1 != p2:
				raise forms.ValidationError('passwords must match')

accounts/views.py
from django.shortcuts import render, redirect
from .forms import UserLoginForm, UserRegistrationForm
from django.contrib.auth import authenticate, login, logout
from django.contrib import messages
from django.contrib.auth.models import User


def user_login(request):
	if request.method == 'POST':
		form = UserLoginForm(request.POST)
		if form.is_valid():
			username = form.cleaned_data['username']
			password = form.cleaned_data['password']
			user = authenticate(request, username=username, password=password)
			if user is not None:
				login(request, user)
				messages.success(request, 'you logged in successfully', 'success')
				return redirect('blog:all_articles')
			else:
				messages.error(request, 'wrong username or password', 'warning')
	else:
		form = UserLoginForm()
	return render(request, 'accounts/login.html', {'form':form})

def user_register(request):
	if request.method == 'POST':
		form = UserRegistrationForm(request.POST)
		if form.is_valid():
			cd = form.cleaned_data
			User.objects.create_user(cd['username'], cd['email'], cd['password1'])
			messages.success(request, 'you registered successfully, now log in', 'success')
			return redirect('accounts:user_login')
	else:
		form = UserRegistrationForm()
	return render(request, 'accounts/register.html', {'form':form})

def user_logout(request):
	logout(request)
	messages.success(request, 'you logged out successfully', 'success')
	return redirect('blog:all_articles')

blog/views.py
from django.shortcuts import render, get_object_or_404
from .models import Article


def all_articles(request):
	all_articles = Article.published.all()
	return render(request, 'blog/all_articles.html', {'all_articles':all_articles})


def article_detail(request, id, slug):
	article = get_object_or_404(Article, id=id, slug=slug)
	return render(request, 'blog/article.html', {'article':article})

accounts/templates/accounts/login.html
{% extends 'base.html' %}

{% block content %}
    <form action="." method="post" novalidate>
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" value="Login">
    </form>

{% endblock %}

accounts/templates/accounts/register.html
{% extends 'base.html' %}

{% block content %}
    <form action="." method="post" novalidate>
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" value="Register" class="btn btn-primary">
    </form>
{% endblock %}

blog/templates/blog/all_articles.html
{% extends 'base.html' %}

{% block content %}

    <div class="card">
        {% for article in all_articles %}
            <a href="{{ article.get_absolute_url }}" class="card-body">{{ article.title }}</a>
        {% endfor %}
    </div>

{% endblock %}

blog/templates/blog/article.html
{% extends 'base.html' %}
{% load static %}


{% block custom_tags %}
<link rel="stylesheet" href="{% static 'blog/css/style.css' %}">
{% endblock %}


{% block content %}
    <h3>{{ article.title }}</h3>
    <small>{{ article.publish|timesince }}</small><hr/>
    <p>{{ article.body|safe }}</p>
{% endblock %}

templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<title>Blog</title>
<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    {% block custom_tags %} {% endblock %}
</head>
<body>


    {% include 'inc/navbar.html' %}
    <div class="jumbotron">
        {% include 'inc/messages.html' %}
        {% block content %} {% endblock %}
    </div>

</body>
</html>

templates/inc/messages.html
{% if messages %}
    {% for message in messages %}
        <p class="alert alert-{{ message.tags }}">{{ message }}</p>
    {% endfor %}
{% endif %}

templates/inc/navbar.html
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
    <div class="navbar-nav">
        <a class="nav-item nav-link" href="{% url 'blog:all_articles' %}">Home</a>
        {% if request.user.is_authenticated %}
        <a class="nav-item nav-link" href="{% url 'accounts:user_logout' %}">Logout</a>
        {% else %}
        <a class="nav-item nav-link" href="{% url 'accounts:user_login' %}">Login</a>
        <a class="nav-item nav-link" href="{% url 'accounts:user_register' %}">Register</a>
        {% endif %}
    </div>
</nav>